;##################################################
;##                                              ##
;##        [ Asm7x.List ][ ISort4S2.inc ]        ##
;##                                              ##
;##             -= Insertion Sort =-             ##
;##     (for double extended element arrays)     ##
;##                                              ##
;##             ஢ ⠢             ##
;##   (ᨢ  묨 ७.⠬)   ##
;##                                              ##
;##           [ v1.00 :: 11.11.2017 ]            ##
;##           MASM/TASM (16 bit 386+)            ##
;##                                              ##
;##     (c) 2017 by Jin X (jin.x@sources.ru)     ##
;##             http://xk7.ru/p/a/i              ##
;##                                              ##
;##################################################

IFDEF		??Version	; TASM
  LOCALS
ENDIF

ISort4S2_ver	=	100h			;    (word: 訩  - 楫 , 訩 - ஡)

; !!!   㫥 ᯮ  ࠢ 祭  ஢   ( 襣  襬)
; !!!     ࠢ  ஢   室  ᮮ⢥騥 樨, 祭   ᨬ ***

;-----------------------------------------------------------------------------------------------------------------------

;-- InsSort4DE:  ᨢ  ---------------------------------------------------------------------------
; > 室 : DS:DX =  ᨢ, CX = - ⮢ ᨢ ( 祭)
; > : ஢ ᨢ ( ⮬  )
;  ᨢ ᮤঠ  2 祭 ⨯ DWORD:
;   * ࢮ  ᫮ ᮤন ୮ 祭 ( ஬ ந室 ࠢ),
;   * ஥  ᫮ - 易  ⮬  (筮  㪠⥫  );
;      ஢ 易  ७   묨 祭ﬨ
; 楤  ॣ EAX, EBX, SI, DI, 襥 ᫮ EBP; ࠭ CX, DX, BP  ᥣ ॣ
InsSort4DE	PROC
		dec	cx
		jle	@@exit			; 室, ᫨ - ⮢ <= 1

		shl	cx,3
		add	cx,dx			; CX =  ᫥ 

		;  楤 ஢ ⠢
		; DX =  ࢮ , CX =  ᫥ , CX > DX
		push	bp
		mov	di,dx			; J (DI) := L -  ࢮ 
	@@next:					;; for J (DI) := L+1 (CX) to R (DX) do
		add	di,8			; J++ (DI) -  ᫥饣 ஢塞  ( ᭮ 横)
		mov	ebx,[di]		;; T (EBP:EBX) := [J]
		mov	ebp,[di+4]
		mov	si,di			; I+1 (SI) = DI -  , ᫥饣  ࠢ ( ७ 横)
	@@loop:					;; repeat
		mov	eax,[si-8]
		cmp	eax,ebx			;; if [I] > T then
		jle	@@break			; 룠, ᫨ [I] <= T {*** ஢  ⠭: jle -  ࠢ, jbe - ;  뢠: jge - , jae - }

		mov	[si],eax		;;  [I+1] := [I] else Break
		mov	eax,[si-8+4]
		mov	[si+4],eax

		sub	si,8			;; Dec(I)
		cmp	si,dx
		jnbe	@@loop			;; until I < L (I+1 <= L)
	@@break:
		mov	[si],ebx		;; [I+1] := T
		mov	[si+4],ebp

		cmp	di,cx
		jnae	@@next			; ᫥騩  ᨢ ;; end for

		pop	bp
	@@exit:	ret
InsSort4DE	ENDP
